package xhttp3.internal.framed;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.zip.Inflater;
import xio.Buffer;
import xio.BufferedSource;
import xio.ByteString;
import xio.ForwardingSource;
import xio.InflaterSource;
import xio.Okio;

class NameValueBlockReader {
   private final InflaterSource inflaterSource;
   private int compressedLimit;
   private final BufferedSource source;

   public NameValueBlockReader(BufferedSource source) {
      NameValueBlockReader var10000 = this;
      NameValueBlockReader var10001 = this;
      super();
      ForwardingSource var2;
      var2 = new ForwardingSource() {
         public long read(Buffer sink, long byteCount) {
            if (NameValueBlockReader.this.compressedLimit == 0) {
               return -1L;
            } else {
               long sink1;
               if ((sink1 = super.read(sink, Math.min(byteCount, (long)NameValueBlockReader.this.compressedLimit))) == -1L) {
                  return -1L;
               } else {
                  NameValueBlockReader.access$022(NameValueBlockReader.this, sink1);
                  return sink1;
               }
            }
         }
      }.<init>(source);
      Inflater source1;
      source1 = new Inflater() {
         public int inflate(byte[] buffer, int offset, int count) {
            int var4;
            if ((var4 = super.inflate(buffer, offset, count)) == 0 && this.needsDictionary()) {
               this.setDictionary(Spdy3.DICTIONARY);
               var4 = super.inflate(buffer, offset, count);
            }

            return var4;
         }
      }.<init>();
      InflaterSource var3;
      InflaterSource var10002 = var3 = new InflaterSource;
      var10002.<init>(var2, source1);
      var10001.inflaterSource = var10002;
      var10000.source = Okio.buffer(var3);
   }

   private ByteString readByteString() {
      NameValueBlockReader var10000 = this;
      int var1 = this.source.readInt();
      return var10000.source.readByteString((long)var1);
   }

   private void doneReading() {
      if (this.compressedLimit > 0) {
         this.inflaterSource.refill();
         if (this.compressedLimit != 0) {
            throw new IOException("compressedLimit > 0: " + this.compressedLimit);
         }
      }

   }

   // $FF: synthetic method
   static int access$022(NameValueBlockReader x0, long x1) {
      return x0.compressedLimit = (int)((long)x0.compressedLimit - x1);
   }

   public List<Header> readNameValueBlock(int length) {
      this.compressedLimit += length;
      if ((length = this.source.readInt()) >= 0) {
         if (length <= 1024) {
            ArrayList var2;
            var2 = new ArrayList.<init>(length);

            for(int var3 = 0; var3 < length; ++var3) {
               ByteString var4 = this.readByteString().toAsciiLowercase();
               ByteString var5 = this.readByteString();
               if (var4.size() == 0) {
                  throw new IOException("name.size == 0");
               }

               Header var6;
               var6 = new Header.<init>(var4, var5);
               var2.add(var6);
            }

            this.doneReading();
            return var2;
         } else {
            throw new IOException("numberOfPairs > 1024: " + length);
         }
      } else {
         throw new IOException("numberOfPairs < 0: " + length);
      }
   }

   public void close() {
      this.source.close();
   }
}
